// jcpplisp.h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
//#include <alloc.h>
#include <math.h>
#include <limits.h>
#include <time.h>

#define LINUXCOMPILER 0 // windowsł0ݒ肷

#define LINE_BUF_SIZE 256
#define BUFLEN 20000
#define FALSE 0
#define TRUE 1
#define CELL_SIZE 3200000L
#define STRING_SIZE 320000L
#define STRING_NUM 100000L
#define NUMBER_SIZE 1600000L
#define INT_SIZE 1600000L
#define GLOBAL_SIZE 3200L
#define FUNCTION_SIZE 3200L
//#define READ_EVAL_NUM 41
#define READ_EVAL_NUM (41 + 28 + 9 + 7 + 5 + 3 + 18 + 5)
#define FILE_POINTER_LEN 10
#define PATH_LEN 256

#define CELL_STACK_SIZE 32000000L
#define LOC_STACK_SIZE 32000000L
#define STATIC_STACK_SIZE 32000L

#define CELL_SIZE_MIN 1000L
#define NUMBER_SIZE_MIN 1000L
#define INT_SIZE_MIN 1000L

#define XORSHIFT_MAX (ULONG_MAX / 10)

#if LINUXCOMPILER
typedef long double LONGDOUBLE;
#else
typedef double LONGDOUBLE;
#endif

typedef int BOOL;

struct _afloat {
	char gc;
	LONGDOUBLE f;
};

typedef struct _afloat AFLOAT;

struct _aint {
	char gc;
	long f;
};

typedef struct _aint AINT;

struct _cell {
	char attr;  // n:_Ai:As:V{Al:XgiRXZjAb:Am:Ar:Aa:z
        char attr2; // u:ʏAc:RŎn܂V{
	char gc;
//        char returnflag; // ʏu
	struct _cell *car;
	struct _cell *cdr;
        struct _cell *mtop;  // lp@ʏNULL
	struct _symval *clj;
	long cljlen;
};

typedef struct _cell CELL;

struct _symval {
	char attr;
	CELL *sym;  // attrs̃Z
	CELL *val;
};

typedef struct _symval SYMVAL;

class ctextproc {
    public:
	int isKanji(unsigned char *str);
	char *SkipDoubleQuote(char *s);
	char *SkipDoubleQuote2(char *s);
	void getCarString(char *u,char *str);
	void getCdrString(char *s,char *str);
	char *taiou(char *b);
	int MakeQuoteText(char *b,int len);
	int MakeFunctionText(char *b,int len);
	int MakeBackQuoteText(char *b,int len);
	int MakeCommaText(char *b,int len);
	int MakeAstText(char *b,int len);
	int CrTabOnly(char *s);
	int CheckBrace(char *s);
	int CheckBrace2(char *s);
	int GetOneS(void);
	int GetOneSStream(FILE *fp);
	void SkipTerm(char *s);
	void princMojiretsu(char *s,FILE *fp);
	unsigned char *getRestchar(char *m);
	void NewString(char *s2,char *s1);
	BOOL isListString(char *str);
	int AnaType(char *u);
	LONGDOUBLE myatof(char *b);
	char *SkipSpc(char *s);
	void getBunshi(char *u,char *re);
	void getBunbo(char *u,char *re);
	void slide(char *b,int len);
	BOOL AllBlank(char *s);
	void SkipComment(FILE *fp);
	void myftoa(char *b,LONGDOUBLE v);
};

class cmathproc {
    public:
	void WaWithTsubun(long a,long b,long c,long d,long *e,long *f);
	void yakubun(long bunshi,long bunbo,long *newbunshi,long *newbunbo);
	long gcd(long x,long y);
	unsigned long XorShift();
};

class cprint : public ctextproc, public cmathproc {
    public:
	void printS(CELL *);
	void princS(CELL *,FILE *);
	void printSStrm(CELL *,FILE *);
	void PutString(CELL *a,FILE *fp);
	void PutStringC(CELL *a,FILE *fp);
	void GetStringC(CELL *a,char *s);
    protected:
	void princS0(CELL *p,BOOL endflag,FILE *fp);
	void printS2Strm(CELL *,BOOL,FILE *);
	void printS3Strm(CELL *,FILE *);
	void printS0(CELL *p,BOOL endflag);
	void printS0Strm(CELL *p,BOOL endflag,FILE *fp);
	void printS2(CELL *,BOOL);
	void printS3(CELL *);
	void princS2(CELL *,BOOL,FILE *);
	void princS3(CELL *,FILE *);
	long jnlength(CELL *c);
};

class cmemory : public cprint {
    private:
	CELL *cl,*curCl;
	char *strArea,*curStr;
	CELL **strAreaAddr,**curStrAddr;
	AFLOAT *nArea,*curN;
	AINT *iArea,*curI;
	SYMVAL *fv,*curFv;

	CELL **CellStack,**curCellStack;
	SYMVAL **LocStack,**curLocStack;
	SYMVAL **StaticStack,**curStaticStack;  // N[Wp
	BOOL GetToEndCell;
    protected:
	long FreeCellSize;
	long FreeNumberSize;
	long FreeIntSize;
	SYMVAL *sv,*curSv;
	FILE *FilePointer[FILE_POINTER_LEN];
	BOOL throw_flag;
	int debug_level;
    public:
	void Init() { GetToEndCell = FALSE; debug_level = 0; }
	BOOL AllocMemory();
	void gc();
	CELL *IncCellStack(CELL *c);
	void PopCellStack();
	int IncLocStack(SYMVAL *loc,long len);
	void PopLocStack();
	CELL *getCell();
	CELL *getMojiCell(char c1,char c2);
	CELL *getStringCell(char *u);
	CELL *get1char(char *m);
	CELL *getMojiretsuCell(char *m);
	CELL *readFromString(char *str);
	CELL *ReadLineStrm(FILE *fp);
	CELL *ReadLine();
	CELL *NumberToCell(LONGDOUBLE v);
	CELL *njExpt(LONGDOUBLE x,CELL *y);
	CELL *ijExpt(long x,CELL *y);
	CELL *bjExpt(long a,long b,CELL *y);
	CELL *jAbs(CELL *p);
	CELL *IntToCell(long v);
	CELL *BunsuToCell(long i,long o);
	CELL *now();
	void InitCellAndNumber();
	AINT *getInt(long f);
	AFLOAT *getNumber(LONGDOUBLE f);
	char *getString(char *str);
	CELL *CheckStringCell(char *u);
	long getRealMojiretsuLen(CELL *p);
	long getSymVal2(CELL *s);
	long getSymVal(CELL *s);
	SYMVAL *getFuncval(CELL *s);
	SYMVAL *getFuncval2(CELL *s);
	void IncStaticStack(SYMVAL *loc,long len);
	long getLocal(SYMVAL *loc,long locn,CELL *s,long lock);
	long CellToInt(CELL *p);
	BOOL isPlus(CELL *p);
	BOOL isPlusExceptZero(CELL *p);
	BOOL isInRange(CELL *p);
	long CellToBunshi(CELL *p);
	long CellToBunbo(CELL *p);
    protected:
	void Disable(CELL *p);
	BOOL initTemplocForMacro(SYMVAL *l,long len,CELL *s,CELL *v);
};

class cfunction : public cmemory {
    private:
	CELL *throw_value,*throw_name;
    public:
	/* jcpplisp.cpp */
	CELL *eval(CELL *,SYMVAL *,long,long);
	CELL *evalu(CELL *top,SYMVAL *loc,long locn,BOOL *multi,long lock);
	CELL *backquote2(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *backquote(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *MakeRest(CELL *v,SYMVAL *loc,long locn,long lock);
	BOOL initTemploc(SYMVAL *l,long len,CELL *s,CELL *v,SYMVAL *loc,long locn,long lock);
	CELL *tprogn(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *tprog1(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *Let(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *MacroExec(CELL *p,SYMVAL *m,SYMVAL *loc,long locn);
	CELL *MacroExec2(CELL *p,SYMVAL *m,SYMVAL *loc,long locn,long lock);
	CELL *LetAst(CELL *p,SYMVAL *loc,long locn,long lock);
	int progBody2(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *progBody(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *prog(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tand(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tor(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *plus(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *OnePlus(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *OneMinus(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *condition(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *tlist(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tlist2(CELL *p,SYMVAL *loc,long locn,CELL **u,long lock);
	CELL *values(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *IfClause(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tclose(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tread(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *minus(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *times(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *divide(CELL *s,SYMVAL *loc,long locn,long lock);
	CELL *apply(CELL *x,CELL *y,SYMVAL *loc,long locn,long lock);
	CELL *funcall(CELL *x,CELL *y,SYMVAL *loc,long locn,long lock);
	CELL *function(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *minusp(CELL *s);
	FILE *getStream(CELL *p);
	FILE *getStream2(CELL *p);
	CELL *tmember(CELL *key,CELL *ob);
	CELL *rplaca(CELL *x,CELL *y,SYMVAL *loc,long locn);
	CELL *rplacd(CELL *x,CELL *y,SYMVAL *loc,long locn);

	/* array.cpp */
	CELL *SetArray(CELL *top,SYMVAL *loc,long locn,long lock);
	CELL *topen(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *coerce(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tchar(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *Random(CELL *max,SYMVAL *loc,long locn,long lock);
	CELL *ArrayCar(CELL *a);
	CELL *ArrayCdr(CELL *a);
	BOOL toPathMojiretsu(CELL *a,unsigned char *name,int maxlen);
	CELL *StringEqual(CELL *a1,CELL *a2);
	CELL *catch_lisp(CELL *p,SYMVAL *loc,long locn);
	CELL *throw_lisp(CELL *p,SYMVAL *loc,long locn);
	CELL *unwind_protect(CELL *p,SYMVAL *loc,long locn);
	CELL *symbol_function(CELL *p,SYMVAL *loc,long locn);

	/* math.cpp */
	CELL *jSqrt(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jExpt(CELL *x,CELL *y,SYMVAL *loc,long locn,long lock);
	CELL *jExp(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jLog(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jSin(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jCos(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jTan(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jAsin(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jAcos(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jAtan(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *jEvenp(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *tfloor(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *LocalTime(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *MakeTime(CELL *p,SYMVAL *loc,long locn,long lock);

	/* linux.cpp */
	CELL *char_to_code(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *code_to_char(CELL *p,SYMVAL *loc,long locn,long lock);
	CELL *symbolname(CELL *p,SYMVAL *loc,long locn);
	CELL *t_intern(CELL *p,SYMVAL *loc,long locn);

	/* others */
    protected:
	CELL *Copy(CELL *p);
	CELL *Wa(CELL *x,CELL *y);
	CELL *Sa(CELL *x,CELL *y);
	CELL *Seki(CELL *x,CELL *y);
	CELL *Sho(CELL *x,CELL *y);
	CELL *SetFilePointer(FILE *fp);
	CELL *jlength(CELL *p);
	CELL *MakeQuoteEach(CELL *p);
	CELL *jcons(CELL *car,CELL *cdr);
	void MultiPrintS(CELL *mtop);
	void SetOrgLoc(SYMVAL *orgloc,long orglen,SYMVAL *temploc,long start,long newlen);
	CELL *LastCell(CELL *p);
	long tlength(CELL *p);
	BOOL CheckFunc(CELL *p);
	CELL *jnth(long n,CELL *c);
	CELL *jprenth(long n,CELL *c);
	BOOL isAllMoji(CELL *p);
	void errorlisp(SYMVAL *loc,long locn);
	CELL *breaklisp(SYMVAL *loc,long locn);
//	void cfunprintS(CELL *p) { printS(p); }
};

class clisp : public cfunction {
    public:
	void SetKeyword();
	BOOL ReadEvalLoop();
	void ReadEvalPrintLoop();
	void DispMessage();
};

///CELL *ArrayCar(CELL *);
///CELL *ArrayCdr(CELL *);

///int isKanji(unsigned char *);
///AINT *getInt(long);
////void PutString(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
////void PutStringC(CELL *,FILE *);  // a = (#\h #\e #\l #\l #\o) etc.
////CELL *ReadLine(void);
////void slide(char *,int);
///CELL *StringEqual(CELL *,CELL *);
///AFLOAT *getNumber(LONGDOUBLE);

////long getLocal(SYMVAL *,long,CELL *,long);

////void DumpSymval(SYMVAL *,long);

//#pragma GCC diagnostic ignored "-Wint-to-pointer-cast"
//#pragma GCC diagnostic ignored "-Wpointer-to-int-cast"
#pragma GCC diagnostic ignored "-Wwrite-strings"

